var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import React from 'react';
import { WelcomePresenter } from '../../shared/Welcome/WelcomePresenter';
import { ButtonType } from '../../types';
import { filterConversionQueries, useWelcomeWidgetConfig, } from '../../hooks/useWelcomeWidget';
export var WelcomeConversion = function () {
    var _a = useWelcomeWidgetConfig(filterConversionQueries), openApp = _a.openApp, loading = _a.loading, error = _a.error, atqId = _a.atqId, greeting = _a.greeting, formattedNewSessionsCount = _a.formattedNewSessionsCount, formattedStartedSessionsCount = _a.formattedStartedSessionsCount, formattedReviewSessionCount = _a.formattedReviewSessionCount;
    var welcomeProps = {
        loading: loading,
        error: error,
        greeting: greeting,
        subTitle: 'Nice to have you here! There is work to do - Let’s go!',
        sessionsButtonsConfig: [
            {
                text: 'Start Conversion',
                onClick: function () { return openApp(atqId, { action: 'show-new-conversion' }); },
                id: 'New Conversion',
                buttonText: 'New Conversion',
                btnType: ButtonType.primary,
                buttonTextCount: formattedNewSessionsCount,
            },
            {
                text: 'Continue Conversion',
                onClick: function () { return openApp(atqId, { action: 'show-started-conversion' }); },
                id: 'Started Conversion',
                buttonText: 'Started Conversion',
                btnType: ButtonType.secondary,
                buttonTextCount: formattedStartedSessionsCount,
            },
            {
                text: 'Start Review',
                onClick: function () {
                    return openApp(atqId, { action: 'show-new-sessions-to-review' });
                },
                id: 'Sessions to be reviewed',
                buttonText: 'Sessions to be reviewed',
                btnType: ButtonType.tertiary,
                buttonTextCount: formattedReviewSessionCount,
            },
        ],
    };
    return React.createElement(WelcomePresenter, __assign({}, welcomeProps));
};
