import React, { useState } from 'react';
import { Icon } from '../Icon';
import { Popover } from '../Popover';
import { Bar, Indicator, PercentageProgressBarContainer, PercentageProgressValue, PercentageProgressWrapper, TickWrapper, } from './styles';
export var PercentageProgressBar = function (_a) {
    var indicator = _a.indicator, popover = _a.popover, progress = _a.progress, withTick = _a.withTick, wrapperWidth = _a.wrapperWidth;
    var _b = useState(null), anchorEl = _b[0], setAnchorEl = _b[1];
    var popoverOpen = Boolean(anchorEl);
    function handleMouseOverIcon(event) {
        setAnchorEl(event.currentTarget);
    }
    function handleMouseLeaveIcon() {
        setAnchorEl(null);
    }
    return (React.createElement(PercentageProgressWrapper, { width: wrapperWidth },
        React.createElement(PercentageProgressValue, null,
            progress,
            "%"),
        React.createElement(PercentageProgressBarContainer, null,
            progress < 100 && React.createElement(Bar, { progress: 100 }),
            progress > 0 && React.createElement(Bar, { progress: progress, active: true }),
            indicator && (React.createElement(Indicator, null,
                React.createElement(Icon, { name: indicator, regular: popoverOpen, fitted: true, size: "large", bordered: true, circular: true, onMouseOver: handleMouseOverIcon, onMouseLeave: handleMouseLeaveIcon }),
                withTick && (React.createElement(TickWrapper, null,
                    React.createElement(Icon, { name: "check", fitted: true, size: "mini", inverted: true, circular: true, color: "primary" })))))),
        popover && (React.createElement(Popover, { offset: -8, placing: "top", anchorElement: anchorEl, isOpen: popoverOpen }, popover))));
};
