var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import React, { useMemo } from 'react';
import styled, { css } from 'styled-components';
import cx from 'clsx';
import defaultCreatedTheme from "../../../theme";
import { textAlign, fixedWidth } from "../../../utils";
import { Icon } from '../Icon';
export var Table = styled.table.attrs(function (props) { return ({
    className: cx({
        sortable: props.sortable,
        striped: props.striped,
        celled: props.celled,
    }),
}); }).withConfig({ displayName: "Table", componentId: "sc-1kweni2" })(templateObject_2 || (templateObject_2 = __makeTemplateObject(["\n  width: 100%;\n  display: table;\n  border-spacing: 0;\n  text-align: left;\n\n  ", "\n"], ["\n  width: 100%;\n  display: table;\n  border-spacing: 0;\n  text-align: left;\n\n  ",
    "\n"])), function (_a) {
    var fixed = _a.fixed;
    return fixed && css(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n      table-layout: fixed;\n\n      td,\n      th {\n        overflow: hidden;\n        text-overflow: ellipsis;\n      }\n    "], ["\n      table-layout: fixed;\n\n      td,\n      th {\n        overflow: hidden;\n        text-overflow: ellipsis;\n      }\n    "])));
});
Table.defaultProps = {
    theme: defaultCreatedTheme,
};
export var TableHeader = styled.thead.withConfig({ displayName: "TableHeader", componentId: "sc-f1mg5j" })(templateObject_3 || (templateObject_3 = __makeTemplateObject(["\n  display: table-header-group;\n  box-sizing: border-box;\n"], ["\n  display: table-header-group;\n  box-sizing: border-box;\n"])));
var SortingWrapper = styled.div.withConfig({ displayName: "SortingWrapper", componentId: "sc-1k8997e" })(templateObject_4 || (templateObject_4 = __makeTemplateObject(["\n  display: flex;\n  align-items: center;\n\n  & > svg {\n    display: inline-block;\n    padding-left: 1em;\n  }\n"], ["\n  display: flex;\n  align-items: center;\n\n  & > svg {\n    display: inline-block;\n    padding-left: 1em;\n  }\n"])));
export var TableHeaderCell = styled(function (_a) {
    var theme = _a.theme, children = _a.children, sorted = _a.sorted, small = _a.small, rest = __rest(_a, ["theme", "children", "sorted", "small"]);
    var arrow = useMemo(function () {
        if (!sorted) {
            return null;
        }
        return sorted === 'ascending' ? (React.createElement(Icon, { name: "caret-up" })) : (React.createElement(Icon, { name: "caret-down" }));
    }, [sorted]);
    if (!sorted) {
        return React.createElement("th", __assign({}, rest, { children: children }));
    }
    return (React.createElement("th", __assign({}, rest),
        React.createElement(SortingWrapper, null,
            children,
            arrow)));
}).withConfig({ displayName: "TableHeaderCell", componentId: "sc-1uenmhu" })(templateObject_5 || (templateObject_5 = __makeTemplateObject(["\n  display: table-cell;\n  padding: ", ";\n  height: ", ";\n  ", "\n\n  box-sizing: border-box;\n  font-weight: normal;\n  text-align: left;\n  border-bottom: 1px solid ", ";\n\n  ", ".celled &:not(:last-child) {\n    border-right: 1px solid ", ";\n  }\n\n  ", ".sortable & {\n    cursor: pointer;\n\n    &:active:hover {\n      background-color: ", " !important;\n    }\n\n    &:focus,\n    &:hover {\n      background-color: ", " !important;\n    }\n  }\n"], ["\n  display: table-cell;\n  padding: ", ";\n  height: ", ";\n  ", "\n\n  box-sizing: border-box;\n  font-weight: normal;\n  text-align: left;\n  border-bottom: 1px solid ", ";\n\n  ", ".celled &:not(:last-child) {\n    border-right: 1px solid ", ";\n  }\n\n  ", ".sortable & {\n    cursor: pointer;\n\n    &:active:hover {\n      background-color: ", " !important;\n    }\n\n    &:focus,\n    &:hover {\n      background-color: ", " !important;\n    }\n  }\n"])), function (_a) {
    var small = _a.small;
    return (small ? '0.5em 1em' : '1em');
}, function (_a) {
    var small = _a.small;
    return (small ? '3em' : '3.5rem');
}, fixedWidth, function (_a) {
    var theme = _a.theme;
    return theme.greyscale.dark;
}, Table, function (_a) {
    var theme = _a.theme;
    return theme.greyscale.medium;
}, Table, function (_a) {
    var theme = _a.theme;
    return theme.greyscale.medium;
}, function (_a) {
    var theme = _a.theme;
    return theme.greyscale.light;
});
TableHeaderCell.defaultProps = {
    theme: defaultCreatedTheme,
};
export var TableBody = styled.tbody.withConfig({ displayName: "TableBody", componentId: "sc-x4b83l" })(templateObject_7 || (templateObject_7 = __makeTemplateObject(["\n  display: table-row-group;\n  position: relative;\n\n  ", "\n"], ["\n  display: table-row-group;\n  position: relative;\n\n  ",
    "\n"])), function (_a) {
    var maxHeight = _a.maxHeight;
    return maxHeight
        ? css(templateObject_6 || (templateObject_6 = __makeTemplateObject(["\n          max-height: ", "px;\n        "], ["\n          max-height: ", "px;\n        "])), maxHeight) : null;
});
var getSelectionColor = function (_a) {
    var theme = _a.theme, positive = _a.positive, negative = _a.negative, highlighted = _a.highlighted;
    if (highlighted) {
        return theme.colors.primary.blured;
    }
    if (positive) {
        return theme.colors.primary.highlighted;
    }
    if (negative) {
        return theme.colors.red.highlighted;
    }
    return theme.greyscale.light;
};
export var TableRow = styled.tr.withConfig({ displayName: "TableRow", componentId: "sc-1ca8xt1" })(templateObject_14 || (templateObject_14 = __makeTemplateObject(["\n  display: table-row;\n  outline: 0;\n  vertical-align: middle;\n  box-sizing: border-box;\n  color: ", ";\n\n  ", "\n\n", "\n\n  ", "\n\n  ", ";\n\n  ", "\n"], ["\n  display: table-row;\n  outline: 0;\n  vertical-align: middle;\n  box-sizing: border-box;\n  color: ", ";\n\n  ",
    "\n\n",
    "\n\n  ",
    "\n\n  ",
    ";\n\n  ",
    "\n"])), function (_a) {
    var theme = _a.theme, negative = _a.negative;
    return (negative ? theme.colors.red.default : '');
}, function (_a) {
    var dimmed = _a.dimmed;
    return dimmed
        ? css(templateObject_8 || (templateObject_8 = __makeTemplateObject(["\n          opacity: 0.5;\n        "], ["\n          opacity: 0.5;\n        "]))) : null;
}, function (_a) {
    var basic = _a.basic;
    return !basic
        ? css(templateObject_9 || (templateObject_9 = __makeTemplateObject(["\n        &:not(:first-child) > td {\n          border-top: 1px solid ", ";\n        }\n      "], ["\n        &:not(:first-child) > td {\n          border-top: 1px solid ", ";\n        }\n      "])), function (_a) {
            var theme = _a.theme;
            return theme.greyscale.medium;
        }) : null;
}, function (_a) {
    var selected = _a.selected;
    return selected
        ? css(templateObject_10 || (templateObject_10 = __makeTemplateObject(["\n          background-color: ", ";\n          font-weight: 600;\n        "], ["\n          background-color: ", ";\n          font-weight: 600;\n        "])), getSelectionColor) : css(templateObject_11 || (templateObject_11 = __makeTemplateObject(["\n          // Striped shouldn't overwrite selection\n          ", ".striped &:nth-child(even) {\n            background-color: ", ";\n          }\n        "], ["\n          // Striped shouldn't overwrite selection\n          ", ".striped &:nth-child(even) {\n            background-color: ", ";\n          }\n        "])), Table, function (_a) {
        var theme = _a.theme;
        return theme.greyscale.lightest;
    });
}, function (_a) {
    var onClick = _a.onClick, theme = _a.theme, highlighted = _a.highlighted;
    return onClick
        ? css(templateObject_12 || (templateObject_12 = __makeTemplateObject(["\n          cursor: pointer;\n\n          &:active:hover {\n            background-color: ", " !important;\n          }\n\n          &:focus,\n          &:hover {\n            background-color: ", " !important;\n          }\n        "], ["\n          cursor: pointer;\n\n          &:active:hover {\n            background-color: ",
            " !important;\n          }\n\n          &:focus,\n          &:hover {\n            background-color: ",
            " !important;\n          }\n        "])), highlighted
            ? theme.colors.primary.blured
            : theme.greyscale.medium, highlighted
            ? theme.colors.primary.verylight
            : theme.greyscale.light) : null;
}, function (_a) {
    var transparent = _a.transparent;
    return transparent && css(templateObject_13 || (templateObject_13 = __makeTemplateObject(["\n      background-color: transparent !important;\n      &:active:hover {\n        background-color: transparent !important;\n      }\n      &:focus,\n      &:hover {\n        background-color: transparent !important;\n      }\n    "], ["\n      background-color: transparent !important;\n      &:active:hover {\n        background-color: transparent !important;\n      }\n      &:focus,\n      &:hover {\n        background-color: transparent !important;\n      }\n    "])));
});
TableRow.defaultProps = {
    theme: defaultCreatedTheme,
};
export var TableCell = styled.td.withConfig({ displayName: "TableCell", componentId: "sc-g2sbr1" })(templateObject_15 || (templateObject_15 = __makeTemplateObject(["\n  display: table-cell;\n  box-sizing: border-box;\n  height: ", ";\n  padding: ", ";\n  max-width: ", ";\n  width: ", ";\n\n  ", ".celled &:not(:last-child) {\n    border-right: 1px solid ", ";\n  }\n\n  ", "\n"], ["\n  display: table-cell;\n  box-sizing: border-box;\n  height: ", ";\n  padding: ", ";\n  max-width: ", ";\n  width: ", ";\n\n  ", ".celled &:not(:last-child) {\n    border-right: 1px solid ", ";\n  }\n\n  ", "\n"])), function (_a) {
    var small = _a.small;
    return (small ? '3rem' : '4rem');
}, function (_a) {
    var fitted = _a.fitted;
    return (fitted ? '0.5em 0' : '0.5em 1em');
}, function (_a) {
    var maxWidth = _a.maxWidth;
    return maxWidth;
}, function (_a) {
    var stretched = _a.stretched, width = _a.width;
    return (stretched ? '100%' : width);
}, Table, function (_a) {
    var theme = _a.theme;
    return theme.greyscale.medium;
}, textAlign);
TableCell.defaultProps = {
    theme: defaultCreatedTheme,
};
var templateObject_1, templateObject_2, templateObject_3, templateObject_4, templateObject_5, templateObject_6, templateObject_7, templateObject_8, templateObject_9, templateObject_10, templateObject_11, templateObject_12, templateObject_13, templateObject_14, templateObject_15;
