import React from 'react';
import { Icon } from "../../elements";
import { DropdownHeader, DropdownHeaderArrowWrapper, DropdownHeaderTitle, } from './styles';
export var DropdownTrigger = function (_a) {
    var dropup = _a.dropup, open = _a.open, color = _a.color, compact = _a.compact, inverted = _a.inverted, text = _a.text, onClear = _a.onClear, disabled = _a.disabled, placeholder = _a.placeholder, onClick = _a.onClick;
    var iconColor = color && (inverted ? color : 'white');
    var handleClick = function () {
        if (onClick && !disabled) {
            onClick();
        }
    };
    var caretIconName = "caret-" + (dropup ? 'up' : 'down');
    var iconName = onClear && text ? 'times' : caretIconName;
    return (React.createElement(DropdownHeader, { isOpen: open, compact: compact, dropup: dropup, color: color, inverted: inverted, disabled: disabled, onClick: handleClick },
        React.createElement(DropdownHeaderTitle, { active: Boolean(text) }, text || placeholder),
        React.createElement(DropdownHeaderArrowWrapper, { compact: compact, color: iconColor, onClick: function (e) {
                if (onClear && text) {
                    e.stopPropagation();
                    onClear();
                }
            } },
            React.createElement(Icon, { name: iconName, size: "medium", color: iconColor }))));
};
