import { getParticipantIds, getReviewerIds, isOwner, isParticipantInReview, isReviewer, } from '../utils';
export var useSessionButtonText = function (session, smeExpert, currentUserId) {
    if (smeExpert === void 0) { smeExpert = false; }
    var archived = session.archived, teachingOwnerId = session.teachingOwnerId, conversionOwnerId = session.conversionOwnerId, handedOver = session.handedOver;
    var reviewerIds = getReviewerIds(smeExpert, session);
    var participantIds = getParticipantIds(smeExpert, session);
    var owner = isOwner(smeExpert, currentUserId, {
        teachingOwnerId: teachingOwnerId,
        conversionOwnerId: conversionOwnerId,
    });
    var reviewer = isReviewer(currentUserId, reviewerIds);
    var participant = isParticipantInReview(currentUserId, participantIds);
    if (archived || (smeExpert && handedOver)) {
        return 'View';
    }
    if (owner) {
        return smeExpert ? 'Continue Teaching' : 'Continue Conversion';
    }
    if (reviewer) {
        return participant ? 'Review' : 'Start Review';
    }
    if (!teachingOwnerId && !conversionOwnerId) {
        return 'Start Teaching';
    }
    if (!smeExpert && !conversionOwnerId) {
        return 'Start Conversion';
    }
    return 'View';
};
